<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>

<p align="right" dir="rtl">
نصب برنامه ها و بسته های نرم افزاری و سرویسهای لازم برای راه اندازی سرور 
</p>

# <p align="right" dir="rtl">گام اول-نصب PHP</p>

```r
sudo apt-get install --dry-run php
```

```r
sudo apt update && sudo apt -y upgrade
```

```r
sudo apt autoremove
```

```r
[ -f /var/run/reboot-required ] && sudo reboot -f
```

<p align="right" dir="rtl">جزئیات انتشار سیستم عامل را می توان با استفاده از دستورات داده شده در اینجا بررسی کرد.</p>

```r
cat /etc/os-release
```

```r
sudo apt install -y lsb-release gnupg2 ca-certificates apt-transport-https software-properties-common
```

```r
sudo add-apt-repository ppa:ondrej/php
```

```r
sudo apt update
```

```r
sudo apt install php8.2
```

```r
php -v
```

# <p align="right" dir="rtl">گام دوم-نصب MariaDB</p>

```r
sudo apt install mariadb-server mariadb-client
sudo mysql_secure_installation
sudo mariadb
```

# <p align="right" dir="rtl">گام سوم-نصب Webserver</p>

<p align="right" dir="rtl">
<span style="background-color:rgb(255,255,0);color:red;font:bold;">
توجه:
</span>
<br>
یکی از این وب سرورها (Apache یا Nginx) باید نصب شود و دیگری بایستی غیر فعال گردد، چون امکان تداخل وجود دارد و این تداخل در روند کار اختلال ایجاد می کند.
</p>

# <p align="right" dir="rtl">1-Apache</p>

```r
sudo apt update
sudo apt install apache2

sudo systemctl start apache2
sudo systemctl enable apache2
sudo systemctl status apache2

```

# <p align="right" dir="rtl">2-Nginx</p>

```r
sudo apt update
sudo apt install nginx

sudo systemctl start nginx
sudo systemctl enable nginx
sudo systemctl status nginx
```

# <p align="right" dir="rtl">گام چهارم-نصب Elasticsearch</p>

## <p align="right" dir="rtl">1-نصب java</p>

```r
sudo apt install openjdk-11-jdk

```

<p dir="rtl" align="right">برای تعریف متغیر محیطی فایل زیر را باز کنید: </p>

```r
sudo nano /etc/environment
```

<p dir="rtl" align="right">متغیر زیر را در فایل قرار دهید: </p>

```r
JAVA_HOME="/usr/lib/jvm/java-11-openjdk-amd64"
```

<p dir="rtl" align="right">متغیر محیطی یا environment را با استفاده از دستور زیر بارگذاری کنید</p>

```r
source /etc/environment
```

## <p dir="rtl" align="right"> 2-نصب ElasticSearch 8 در Ubuntu 20.04 LTS </p>

<p dir="rtl" align="right">کلید امضای عمومی را دانلود و نصب کنید، اگر می‌خواهید آخرین Elasticsearch را دانلود کنید، به صفحه دانلود رسمی Elastic Stack مراجعه کنید.</p>

```r
wget -qO - https://artifacts.elastic.co/GPG-KEY-elasticsearch | sudo gpg --dearmor -o /usr/share/keyrings/elasticsearch-keyring.gpg
```

<p dir="rtl" align="right">تعریف مخزن را در این فایل ذخیره کنید: /etc/apt/sources.list.d/elastic-8.x.list:</p>

```r
echo "deb [signed-by=/usr/share/keyrings/elasticsearch-keyring.gpg] https://artifacts.elastic.co/packages/8.x/apt stable main" | sudo tee /etc/apt/sources.list.d/elastic-8.x.list
```

```r
sudo apt-get update
sudo apt-get install elasticsearch

sudo systemctl start elasticsearch
sudo systemctl enable elasticsearch
sudo systemctl status elasticsearch

```

<p dir="rtl" align="right"> تنظیمات فایل پیکربندی</p>

```r
sudo nano /etc/elasticsearch/elasticsearch.yml
```

<p dir="rtl" align="right"> به بخش Network بروید و network.host را از نظر خارج کنید و IP سیستم خود را جایگزین کنید</p>

```r
network.host: 0.0.0.0
```

<p dir="rtl" align="center">صلوات</p>
