<p dir="rtl" align="center">بسم الله الرحمن الرحیم</p>

<div dir="rtl" align="justify">

# نحوه نصب SSH در اوبونتو سرور

SSH به طور پیش فرض بر روی سیستم های دسکتاپ اوبونتو نصب نمی شود اما می توان به راحتی آن را از مخازن استاندارد اوبونتو نصب کنید. برای اینکه بتوانید عملیات نصب و فعال سازی SSH را روی سرور لینوکس اوبونتو انجام دهید، کافیست دستورات زیر را به ترتیب رعایت کنید:

در ابتدا باید بتوانید ترمینال سیستم خود را باز کنید. برای این کار می توانید از میانبر صفحه کلید Ctrl + Alt + T استفاده کنید و یا بر روی آیکون این برنامه کلیک کنید و سپس به راحتی آن را باز کنید و سپس پکیج openssh-server را نصب کنید. برای این کار کافیست دستور زیر را وارد کنید:
<div align="left">

```r
sudo apt update
sudo apt install openssh-server
```

</div>
پس از درخواستی که به شما ارسال می شود باید رمز عبور را وارد کنید و برای ادامه پیدا کردن روند نصب حرف Y را وارد کنید.

پس از اتمام نصب، سرویس SSH به طور خودکار شروع به کار می کند. برای تایید اینکه نصب موفقیت آمیز بوده و سرویس SSH در حال اجراست، دستور زیر را که وضعیت سرور SSH را پرینت خواهد گرفت، تای و سپس اجرا کنید:

<div align="left">

```r
sudo systemctl status ssh
```

</div>


اوبونتو با یک ابزار پیکربندی firewall که با نام UFW شناخته شده است، همراه می باشد. اگر firewall بر روی سیستم شما فعال شده است، اطمینان حاص کنید که پورت SSH را باز کرده اید. برای این کار کافیست تا دستور زیر را وارد کنید:

<div align="left">

```r
sudo ufw allow ssh
```

</div>

اکنون که SSH بر روی سیستم اوبونتو نصب و راه اندازی شده است، می توانید از طریق دستگاه SSH به هر ماشین از راه دوری که می خواهید متصل شوید. دو سیستم لینوکس و macOS دارای سرویس های SSH هستند که به صورت پیش فرض نصب شده اند. اگر می خواهید به وسیله یک دستگاه ویندوز متصل شوید می توانید از یک مشتری SSH مانند PuTTY استفاده کنید.
اتصال به SSH در اوبونتو از طریق LAN

برای اینکه بتوانید به دستگاه اوبونتو از طریق LAN اتصال پیدا کنید، تنها کاری که باید انجام دهید این است که دستور زیر را وارد کنید:


<div align="left">

```r
ssh username@ip_address
```
</div>


در این دستور پورت را به طور پیشفرض 22 در نظر می گیرد، ولی اگر پورت را تغییر داده باشید بایستی با دستور زیر شماره پورت را وارد نمایید.
مثال: فرض کنید پورت را به 2222 تغییر داده ایم.
البته باید این را در نظر داشته باشید از آن جایی که پورت اتصال به دایرکت ادمین نیز 2222 است، ممکن است در برخی از فایروال ها ایجاد مشکل می کند، پس بهتر است تا پورت دیگری را انتخاب نمائید.

<div align="left">

```r
ssh username@ip_address -p 2222
```
</div>

## نحوه ی تغییر پورت SSH: 

<div align="left">

```r
sudo nano /etc/ssh/sshd_config
```

</div>
باید در این فایل به دنبال یکی از خطوط زیر باشید

<p style="background-color:black;color:white;"  align="left">
    <code>
Port 22
#Port 22
    </code>
</p>

ابتدا #را حذف کنید و سپس به جای عدد 22 شماره پورتی که می خواهید به آن متصل شوید را وارد نمایید. مثلا 2222 سپس با CTRL+O تغییرات را ذخیره نموده و با CTRL+X از فایل خارج شوید.

یوزر نیم را با نام کاربری واقعی و ip_address را با آدرس IP دستگاه اوبونتو که در آن SSH را نصب کرده اید، تغییر دهید و یا جایگزین کنید. اگر آدرس IP خود را نمی دانید و از آن اطلاعی ندارید، به راحتی می توانید با استفاده از دستور زیر، آن را پیدا کنید:

<div align="left">

```r
ip a
```

</div>


پس از یافتن آدرس ip با استفاده از اجرای دستور SSH زیر، می توانید به دستگاه از راه دور وارد شوید:

<div align="left">

```r
ssh username@192.168.121.111 -p 22
```

</div>




هنگامی که برای اولین بار از طریق SSH متصل می شوید، پیامی را مانند چیزی که در ادامه آورده خواهد شد، مشاهده می کنید:
<p style="background-color:black;color:white;"  align="left">
    <code>
The authenticity of host '192.168.121.111 (192.168.121.111)' can't be established.
ECDSA key fingerprint is SHA256:Vybt22mVXuNuB5unE++yowF7lgA/9/2bLSiO3qmYWBY.
Are you sure you want to continue connecting (yes/no)?
    </code>
</p>
برای اتصال نهایی از شما تاییدیه خواسته می شود. به همین علت شما باید بله را تایپ کنید و بعد دوباره درخواست رمز عبور از شما خواسته خواهد شد که به ترتیب باید گذرواژه مورد نظرتان را تایپ و وارد کنید. در این صورت دستوری مانند آنچه که در ادامه آورده خواهد شد، مشاهده می کنید:
<p style="background-color:black;color:white;"  align="left">
    <code>
Warning: Permanently added '192.168.121.111' (ECDSA) to the list of known hosts.
linuxize@192.168.121.111's password:
    </code>
</p>
پس از وارد کردن رمز عبور، پیغامی مثل مورد زیر را دریافت خواهید کرد:
<p style="background-color:black;color:white;"  align="left">
    <code>
Welcome to Ubuntu 18.04.1 LTS (GNU/Linux 4.15.0-33-generic x86_64)
 * Documentation:  https://help.ubuntu.com
 * Management:     https://landscape.canonical.com
 * Support:        https://ubuntu.com/advantage
...
    </code>
</p>
در صورت دیدن نتیجه فوق، شما موفق شده اید که وارد دستگاه اوبونتو شوید.
اتصال به SSH از طریق اینترنت

برای اتصال به دستگاه اوبونتو با استفاده از اینترنت، در ابتدا باید آدرس IP عمومی خود را بشناسید و سپس روتر خود را پیکربندی کنید. این کار برای این است تا دستگاه بتواند داده های پورت 22 را قبول کند و سپس آن را به دستگاه اوبونتویی که SSH در آن جا کار می کند، ارسال کند.

برای اینکه بتوانید آدرس عمومی IP خود را پیدا کنید، کافیست تا به آدرس زیر مراجعه کنید:

<div align="left">

```r
https://ifconfig.co/ip
```

</div>

هنگامی که می خواهید قسمت ارسال پورت را تنظیم کنید باید بدانید که هر روتر روش خاصی را برای ارسال پورت دارد. برای این کار شما باید اسناد روتر سیستم را در مورد نحوه ارسال و تنظیم پورت مورد بررسی قرار دهید و شما باید شماره پورت درخواستی تان را ارسال کنید (پورت پیش فرض SSH، 22 است) و سپس آدرس IP خصوصی که را زودتر آن را پیدا کرده اید را وارد می کنید. تمام این کارها در SSH انجام می گیرد.

هنگامی که آدرس IP را پیدا و روتر خود را پیکربندی کردید، می توانید با تایپ کردن دستور زیر وارد سیستم شوید:

<div align="left">

```r
ssh username@public_ip_address -p 22
```

</div>

اگر دستگاه خود را به اینترنت متصل می کنید، ایده بسیار خوبی به شما می رود. زیرا با استفاده از اینترنت می توان برخی از اقدامات امنیتی را به راحتی انجام داد. یکی از اساسی ترین کارهایی که باید انجام دهید این است که روتر خود را به منظور پذیرش ترافیک موجود در SSH بر روی پورت غیر استاندارد پیکربندی کنید و آن را به پورتی با نام 22 ارسال کنید. این پورت باید در دستگاهی باشد که سرویس SSH را اجرا می کند.

همچنین شما می توانید احراز هویت مبتنی بر کلید SSH را تنظیم کنید و بدون اینکه بخواهید رمز عبوری را وارد کنید، به دستگاه اوبونتو متصل شوید.
غیر فعال کردن SSH در اوبونتو

اگر به خاطر دلایل مختلفی می خواهید تا SSH را در دستگاه اوبونتو غیر فعال کنید، به راحتی می توانید با وارد کردن دستگاه زیر مانع از اجرا آن شوید:

<div align="left">

```r
sudo systemctl stop ssh
```

</div>

برای اجرا دوباره آن می توانید از دستور زیر بهره ببرید:

<div align="left">

```r
sudo systemctl start ssh
```

</div>

برای غیر فعال کردن سرویس SSH به منظور شروع آن در هنگام سیستم بوت، نیاز است تا دستور زیر را اجرا کنید:

<div align="left">

```r
sudo systemctl disable ssh
```

</div>

همچنین برای فعال کردن دوباره آن، دستور زیر را اجرا کنید:

<div align="left">

```r
sudo systemctl enable ssh
```

</div>

نصب و استفاده از ssh در اوبونتو می تواند به شما این امکان را بدهد تا امنیت بسیار بیشتری را در هنگام ارسال فایل ها و اطلاعات مختف تجربه کنید.
</div>

<p dir="rtl" align="center">صلوات</p>